package dcphone10

import (
	"devphone10/jeffutil"
	"fmt"
	"net"
	"time"
)

var TotalConnectErr = 0
var TotalSendErr = 0

var myDevType byte = 0x5A

// 连上服务器,然后每分钟发状态心跳
func TcpConnect(serverAddr string, myDevID uint32) {
	conn, err := net.Dial("tcp", serverAddr)
	if err != nil {
		TotalConnectErr++
		fmt.Println(myDevID, TotalConnectErr, "-connect err:", err)
		return
	}
	defer conn.Close()

	for {
		if err2 := upHeartStatus(conn, myDevID); err2 != nil {
			TotalSendErr++
			fmt.Println(myDevID, TotalSendErr, "-send err:", err)
			break
		}
		time.Sleep(time.Minute)
	}
}

func getOneCiphertext(myDevID uint32, ctrlCode byte, data []byte) []byte {
	cleartext := make([]byte, len(data)+12)
	nowTimeUtc := uint32(time.Now().Unix())
	cleartext[0] = byte(nowTimeUtc)
	cleartext[1] = byte(nowTimeUtc >> 8)
	cleartext[2] = byte(nowTimeUtc >> 16)
	cleartext[3] = byte(nowTimeUtc >> 24)
	cleartext[4] = myDevType
	cleartext[5] = byte(myDevID)
	cleartext[6] = byte(myDevID >> 8)
	cleartext[7] = byte(myDevID >> 16)
	cleartext[8] = ctrlCode
	cleartext[9] = byte(len(data))
	copy(cleartext[10:], data)
	jeffutil.GetCRC(cleartext, len(data)+10)

	return jeffutil.EncryptBytesToBase64(cleartext, "DCRYM-2018-pswd.", "I can't tell YOU")
}

//
func upHeartStatus(conn net.Conn, myDevID uint32) error {
	data := make([]byte, 3)
	data[0] = 30
	data[1] = 31
	data[2] = 9
	sendData := getOneCiphertext(myDevID, 0x41, data)
	sendData[0] = '{'
	sendData[len(sendData)-1] = '}'

	_, err1 := conn.Write(sendData)
	if err1 != nil {
		return err1
	}

	buf := make([]byte, 100)
	conn.SetReadDeadline(time.Now().Add(3 * time.Second))
	/*cnt*/ _, err := conn.Read(buf)
	if err != nil {
		fmt.Printf("接收服务器响应心跳失败-------")
		return err
	}
	// todo 处理服务器响应
	//if cnt != 8 || string(buf[:cnt]) != "jefftest" {
	//	arr := strings.Split(string(buf[:cnt]),"jefftest")
	//	for _,value := range arr{
	//		if len(value)>0 {
	//			fmt.Printf("client%d:接收到非握手数据:%s\n", i+1, value)
	//		}
	//	}
	//}
	return nil
}

func UserGetFamilyNum() {

}

func UserGetFamilyMsg() {

}
